diff -uwr sourceold/scripts/engine_obj2.h source/scripts/engine_obj2.h
--- sourceold/scripts/engine_obj2.h	2011-10-20 22:21:42.989257800 +0800
+++ source/scripts/engine_obj2.h	2012-02-13 18:26:42.432039000 +0800
@@ -47,4 +47,5 @@
 GameObject SCRIPTS_API *Get_Vehicle_Gunner_Pos(GameObject *obj); //Get the vehicle gunner, returns zero if there is no gunner
 void SCRIPTS_API Set_Vehicle_Is_Visible(GameObject *obj,bool visible); //works like Set_Is_Visible but for vehicles, makes them be ignored by Enemy_Seen
 void SCRIPTS_API Set_Vehicle_Gunner(GameObject *obj,int seat); //set gunner for this vehicle
+bool SCRIPTS_API Is_Spy(GameObject *obj); //Is this soldier object a spy
 #endif
diff -uwr sourceold/scripts/engine_player.cpp source/scripts/engine_player.cpp
--- sourceold/scripts/engine_player.cpp	2011-10-11 23:03:20.238281200 +0800
+++ source/scripts/engine_player.cpp	2012-01-18 06:45:15.295898400 +0800
@@ -418,7 +418,7 @@
 		if (o && As_SoldierGameObj(o))
 		{
 			const char *name = Get_Player_Name(o);
-			if (!stristr(name,name1))
+			if (stristr(name,name1))
 			{
 				current = o;
 				count++;
@@ -447,7 +447,7 @@
 		if (o && As_SoldierGameObj(o))
 		{
 			const char *name = Get_Player_Name(o);
-			if (!stristr(name,name1))
+			if (stristr(name,name1))
 			{
 				count++;
 			}
diff -uwr sourceold/scripts/engine_string.h source/scripts/engine_string.h
--- sourceold/scripts/engine_string.h	2011-10-11 21:53:52.137695300 +0800
+++ source/scripts/engine_string.h	2012-01-11 20:59:06.570312500 +0800
@@ -594,6 +594,7 @@
 	SHADERS_API bool Is_ANSI(void);
 	wchar_t *		Get_Buffer (int new_length);
 	wchar_t *		Peek_Buffer (void);
+	const wchar_t*	Peek_Buffer() const;
 	SHADERS_API static void	Release_Resources (void);
 
 	void TruncateLeft(uint truncateLength)
@@ -907,6 +908,11 @@
 {
 	return m_Buffer;
 }
+
+inline const wchar_t* WideStringClass::Peek_Buffer() const
+{
+	return m_Buffer;
+}
 
 inline const WideStringClass &WideStringClass::operator+= (const WideStringClass &string)
 {
diff -uwr sourceold/scripts/engine_tt.cpp source/scripts/engine_tt.cpp
--- sourceold/scripts/engine_tt.cpp	2011-11-07 20:07:04.130859300 +0800
+++ source/scripts/engine_tt.cpp	2012-02-27 12:46:32.940882800 +0800
@@ -24,6 +24,7 @@
 #include "SmartGameObjDef.h"
 #include "VehicleGameObj.h"
 #include "SoldierGameObj.h"
+#include "SoldierGameObjDef.h"
 #include "VehicleFactoryGameObj.h"
 #include "VehicleFactoryGameObjDef.h"
 #include "AirFactoryGameObj.h"
@@ -34,6 +35,7 @@
 SCRIPTS_API gpl Get_Player_List;
 SCRIPTS_API gcmi Get_Current_Map_Index;
 SCRIPTS_API gm Get_Map;
+SCRIPTS_API gmc Get_Map_Count;
 SCRIPTS_API smx Set_Map;
 SCRIPTS_API ggd Get_Game_Definitions;
 SCRIPTS_API _Enable_Stealth_Player Enable_Stealth_Player;
@@ -70,6 +72,8 @@
 SCRIPTS_API allh AddThinkHook;
 SCRIPTS_API apjh AddPlayerJoinHook;
 SCRIPTS_API arch AddRadioHook;
+SCRIPTS_API asdh AddStockDamageHook;
+SCRIPTS_API atdh AddTtDamageHook;
 SCRIPTS_API aplh AddPlayerLeaveHook;
 SCRIPTS_API aph AddPowerupPurchaseHook;
 SCRIPTS_API aph AddVehiclePurchaseHook;
@@ -113,6 +117,7 @@
 SCRIPTS_API dps Display_Security_Dialog;
 SCRIPTS_API geo GetExplosionObj;
 SCRIPTS_API seo SetExplosionObj;
+SCRIPTS_API uno Update_Network_Object;
 SCRIPTS_API dod Do_Objectives_Dlg;
 SCRIPTS_API sl Set_Player_Limit;
 SCRIPTS_API gl Get_Player_Limit;
@@ -148,7 +153,6 @@
 SCRIPTS_API scap Send_Custom_All_Players;
 SCRIPTS_API stc Steal_Team_Credits;
 SCRIPTS_API gtc Get_Team_Credits;
-SCRIPTS_API ssn Set_Objects_Filename;
 SCRIPTS_API addConnectionAcceptanceFilterType addConnectionAcceptanceFilter;
 SCRIPTS_API removeConnectionAcceptanceFilterType removeConnectionAcceptanceFilter;
 SCRIPTS_API ec Evict_Client;
@@ -371,68 +375,158 @@
 
 SCRIPTS_API void Ranged_Stealth_On_Team(Gap_ListNode* FirstNode)
 {
-	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
+	SLNode<VehicleGameObj> *x = GameObjManager::VehicleGameObjList.Head();
 	if (FirstNode)
 	{
 		while (x)
 		{
-			GameObject *o = x->Data();
+			VehicleGameObj *o = x->Data();
 			if (o)
 			{
-				bool tested = false;
+				bool stealth = false;
 				Gap_ListNode *current = FirstNode;
 				int test = Commands->Get_Player_Type(o);
-				if (o->As_VehicleGameObj() && o->As_VehicleGameObj()->Get_Lock_Team() != 2)
+				if (o->Get_Lock_Team() != 2)
 				{
-					test = o->As_VehicleGameObj()->Get_Lock_Team();
+					test = o->Get_Lock_Team();
 				}
-				SmartGameObjDef *d = (SmartGameObjDef *)Get_Definition(o);
+				const VehicleGameObjDef *d = &o->Get_Definition();
 				if (!d->Is_Stealthed())
 				{
-					if (Is_Vehicle(o) || Is_Soldier(o))
-					{
-						while (!tested)
-						{
-							if (current)
+					while (current)
 							{
 								if (current->active)
 								{
+							if (test == current->teamID)
+							{
 									Vector3 GenPos = Commands->Get_Position(Commands->Find_Object(current->unitID));
 									Vector3 TargetPos = Commands->Get_Position(o);
-									float distance = Commands->Get_Distance(GenPos, TargetPos);
-									if (distance <= current->range)
+								float distance2 = (GenPos - TargetPos).Length2();
+								if (distance2 <= current->range * current->range)
 									{
-										if (test == current->teamID)
-										{
-											Commands->Enable_Stealth(o, true);
-											current = NULL;
-											tested = true;
+									stealth = true;
+								}
+							}
 										}
-										else
-										{
 											current = current->Next;
 										}
+					Commands->Enable_Stealth(o, stealth);
+					current = NULL;
+				}
+			}
+			x = x->Next();
+		}
 									}
 									else
 									{
-										current = current->Next;
+		while (x)
+		{
+			VehicleGameObj *o = x->Data();
+			if (o)
+			{
+				const VehicleGameObjDef *d = &o->Get_Definition();
+				if (!d->Is_Stealthed())
+				{
+					Commands->Enable_Stealth(o, false);
 									}
 								}
-								else
+			x = x->Next();
+		}
+	}
+
+	SLNode<SoldierGameObj> *x2 = GameObjManager::SoldierGameObjList.Head();
+	if (FirstNode)
+	{
+		while (x2)
+		{
+			SoldierGameObj *o = x2->Data();
+			if (o)
+			{
+				bool stealth = false;
+				Gap_ListNode *current = FirstNode;
+				int test = Commands->Get_Player_Type(o);
+				const SoldierGameObjDef *d = &o->Get_Definition();
+				if (!d->Is_Stealthed())
 								{
+					while (current)
+					{
+						if (current->active)
+						{
+							if (test == current->teamID)
+							{
+								Vector3 GenPos = Commands->Get_Position(Commands->Find_Object(current->unitID));
+								Vector3 TargetPos = Commands->Get_Position(o);
+								float distance2 = (GenPos - TargetPos).Length2();
+								if (distance2 <= current->range * current->range)
+								{
+									stealth = true;
+								}
+							}
+						}
 									current = current->Next;
 								}
+					Commands->Enable_Stealth(o, stealth);
+					current = NULL;
+				}
+			}
+			x2 = x2->Next();
+		}
 							}
 							else
 							{
+		while (x2)
+		{
+			SoldierGameObj *o = x2->Data();
+			if (o)
+			{
+				const SoldierGameObjDef *d = &o->Get_Definition();
+				if (!d->Is_Stealthed())
+				{
 								Commands->Enable_Stealth(o, false);
-								current = NULL;
-								tested = true;
 							}
 						}
+			x2 = x2->Next();
 					}
 				}
 			}
+
+SCRIPTS_API void Ranged_Gap_Effect(Gap_ListNode* FirstNode)
+{
+	SLNode<VehicleGameObj> *x = GameObjManager::VehicleGameObjList.Head();
+	if (FirstNode)
+	{
+		while (x)
+		{
+			VehicleGameObj *o = x->Data();
+			if (o)
+			{
+				bool stealth = false;
+				Gap_ListNode *current = FirstNode;
+				int test = Commands->Get_Player_Type(o);
+				const VehicleGameObjDef *d = &o->Get_Definition();
+				if (!d->Is_Stealthed() && d->Get_Type() != VEHICLE_TYPE_SUB)
+				{
+					while (current)
+					{
+						if (current->active)
+						{
+							Vector3 GenPos = Commands->Get_Position(Commands->Find_Object(current->unitID));
+							Vector3 TargetPos = Commands->Get_Position(o);
+							float distance2 = (GenPos - TargetPos).Length2();
+							if (distance2 <= current->range * current->range)
+							{
+								if (test == current->teamID)
+								{
+									stealth = true;
+								}
+							}
+						}
+						current = current->Next;
+					}
+					Commands->Enable_Stealth(o, stealth);
+					current = NULL;
+				}
+			}
 			x = x->Next();
 		}
 	}
@@ -440,41 +534,33 @@
 	{
 		while (x)
 		{
-			GameObject *o = x->Data();
+			VehicleGameObj *o = x->Data();
 			if (o)
 			{
-				SmartGameObjDef *d = (SmartGameObjDef *)Get_Definition(o);
+				const VehicleGameObjDef *d = &o->Get_Definition();
 				if (!d->Is_Stealthed())
 				{
-					if (Is_Vehicle(o) || Is_Soldier(o))
-					{
 						Commands->Enable_Stealth(o, false);
 					}
 				}
-			}
 			x = x->Next();
 		}
 	}
-}
 
-SCRIPTS_API void Ranged_Gap_Effect(Gap_ListNode* FirstNode)
-{
-	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
+	SLNode<SoldierGameObj> *x2 = GameObjManager::SoldierGameObjList.Head();
 	if (FirstNode)
 	{
-		while (x)
+		while (x2)
 		{
-			GameObject *o = x->Data();
+			SoldierGameObj *o = x2->Data();
 			if (o)
 			{
 				bool stealth = false;
 				bool blackout = false;
 				Gap_ListNode *current = FirstNode;
 				int test = Commands->Get_Player_Type(o);
-				SmartGameObjDef *d = (SmartGameObjDef *)Get_Definition(o);
-				if (!d->Is_Stealthed() && !Is_Script_Attached(o,"JFW_Submarine"))
-				{
-					if (Is_Vehicle(o) || Is_Soldier(o))
+				const SoldierGameObjDef *d = &o->Get_Definition();
+				if (!d->Is_Stealthed())
 					{
 						while (current)
 						{
@@ -482,8 +568,8 @@
 							{
 								Vector3 GenPos = Commands->Get_Position(Commands->Find_Object(current->unitID));
 								Vector3 TargetPos = Commands->Get_Position(o);
-								float distance = Commands->Get_Distance(GenPos, TargetPos);
-								if (distance <= current->range)
+							float distance2 = (GenPos - TargetPos).Length2();
+							if (distance2 <= current->range * current->range)
 								{
 									if (test == current->teamID)
 									{
@@ -512,22 +598,19 @@
 						current = NULL;
 					}
 				}
-			}
-			x = x->Next();
+			x2 = x2->Next();
 		}
 	}
 	else
 	{
-		while (x)
+		while (x2)
 		{
-			GameObject *o = x->Data();
+			SoldierGameObj *o = x2->Data();
 			if (o)
 			{
-				SmartGameObjDef *d = (SmartGameObjDef *)Get_Definition(o);
+				const SoldierGameObjDef *d = &o->Get_Definition();
 				if (!d->Is_Stealthed())
 				{
-					if (Is_Vehicle(o) || Is_Soldier(o))
-					{
 						Commands->Enable_Stealth(o, false);
 						if (Commands->Is_A_Star(o))
 						{
@@ -535,8 +618,7 @@
 						}
 					}
 				}
-			}
-			x = x->Next();
+			x2 = x2->Next();
 		}
 	}
 }
diff -uwr sourceold/scripts/engine_tt.h source/scripts/engine_tt.h
--- sourceold/scripts/engine_tt.h	2011-11-07 20:07:04.007812500 +0800
+++ source/scripts/engine_tt.h	2012-02-27 12:46:32.867640600 +0800
@@ -58,6 +58,8 @@
 typedef void (*apjh) (PlayerJoin h);
 typedef void (*aplh) (PlayerLeave h);
 typedef void (*arch) (RadioHook h);
+typedef void (*asdh) (StockDamageHook h);
+typedef void (*atdh) (TtDamageHook h);
 typedef const char *(*gcmt) ();
 typedef double (*gttv) ();
 typedef void (*sit) (GameObject *obj,const char *texture);
@@ -126,12 +128,15 @@
 typedef const char * (*gcsh) (int clientId);
 typedef int (*gcmi) ();
 typedef const char * (*gm) (int index);
+typedef const int (*gmc) ();
 typedef bool (*smx) (const char *map,int index);
 typedef void (*ggd) (HashTemplateClass<StringClass, GameDefinition> &definitions);
 typedef SList<cPlayer> *(*gpl) ();
+typedef void (*uno) (NetworkObjectClass *obj);
 SCRIPTS_API extern gpl Get_Player_List;
 SCRIPTS_API extern gcmi Get_Current_Map_Index;
 SCRIPTS_API extern gm Get_Map;
+SCRIPTS_API extern gmc Get_Map_Count;
 SCRIPTS_API extern smx Set_Map;
 SCRIPTS_API extern ggd Get_Game_Definitions;
 SCRIPTS_API extern ec Evict_Client;
@@ -164,6 +169,8 @@
 SCRIPTS_API extern allh AddThinkHook;
 SCRIPTS_API extern apjh AddPlayerJoinHook;
 SCRIPTS_API extern arch AddRadioHook;
+SCRIPTS_API extern asdh AddStockDamageHook;
+SCRIPTS_API extern atdh AddTtDamageHook;
 SCRIPTS_API extern aplh AddPlayerLeaveHook;
 SCRIPTS_API extern aph AddPowerupPurchaseHook;
 SCRIPTS_API extern aph AddVehiclePurchaseHook;
@@ -226,6 +233,7 @@
 SCRIPTS_API extern shn Send_HUD_Number;
 SCRIPTS_API extern geo GetExplosionObj;
 SCRIPTS_API extern seo SetExplosionObj;
+SCRIPTS_API extern uno Update_Network_Object;
 SCRIPTS_API extern dod Do_Objectives_Dlg;
 SCRIPTS_API extern sl Set_Player_Limit;
 SCRIPTS_API extern gl Get_Player_Limit;
@@ -249,7 +257,6 @@
 SCRIPTS_API extern sbd Set_Special_Base_Destruction;
 SCRIPTS_API extern gpv Get_Client_Version;
 SCRIPTS_API extern gdw Get_Damage_Warhead;
-SCRIPTS_API extern ssn Set_Objects_Filename;
 SCRIPTS_API extern addConnectionAcceptanceFilterType addConnectionAcceptanceFilter;
 SCRIPTS_API extern removeConnectionAcceptanceFilterType removeConnectionAcceptanceFilter;
 
diff -uwr sourceold/scripts/engine_ttdef.h source/scripts/engine_ttdef.h
--- sourceold/scripts/engine_ttdef.h	2011-10-11 21:53:21.451171800 +0800
+++ source/scripts/engine_ttdef.h	2012-02-18 09:50:34.036132800 +0800
@@ -14,7 +14,8 @@
 #include "scripts.h"
 
 class BaseControllerClass;
-
+class PhysicalGameObj;
+class AmmoDefinitionClass;
 
 enum TextMessageEnum
 {
@@ -34,6 +35,8 @@
 typedef void (*PurchaseMonHook) (BaseControllerClass *base,GameObject *purchaser,unsigned int cost,unsigned int preset,unsigned int purchaseret,const char *data);
 typedef bool (*RefillHook) (GameObject *purchaser);
 typedef bool (*RadioHook) (int PlayerType, int PlayerID, int AnnouncementID, int IconID, uint8 AnnouncementType);
+typedef bool (*StockDamageHook) (PhysicalGameObj* damager, PhysicalGameObj* target, float damage, uint warheadId);
+typedef bool (*TtDamageHook) (PhysicalGameObj* damager, PhysicalGameObj* target, const AmmoDefinitionClass* ammo, const char* bone);
 
 struct ObjectCreateHookStruct {
 	ObjectCreateHook hook;
diff -uwr sourceold/scripts/gmgame.cpp source/scripts/gmgame.cpp
--- sourceold/scripts/gmgame.cpp	2011-11-07 20:41:54.807617100 +0800
+++ source/scripts/gmgame.cpp	2012-02-18 09:50:34.050781200 +0800
@@ -38,7 +38,6 @@
 HashTemplateClass<StringClass,DynamicVectorClass<StringClass> *> WeaponDrops;
 char *GDISpawnChar;
 char *NodSpawnChar;
-char *ObjectsFilename;
 DynamicVectorClass<int> DisablePresets;
 DynamicVectorClass<int> MapDisablePresets;
 HashTemplateClass<StringClass,StringClass> VehicleWreckages;
@@ -102,21 +101,6 @@
 	{
 		return newstr("None");
 	}
-	if (Is_C4(obj))
-	{
-		if (Get_C4_Mode(obj) == 1)
-		{
-			return newstr("Remote C4");
-		}
-		else if (Get_C4_Mode(obj) == 3)
-		{
-			return newstr("Proximity C4");
-		}
-		else if (Get_C4_Mode(obj) == 2)
-		{
-			return newstr("Timed C4");
-		}
-	}
 	const char *preset = Get_Translated_Preset_Name_Ini(obj);
 	StringClass preset2 = preset;
 	if (Is_Building(obj) || Is_DecorationPhys(obj) || Is_Harvester_Preset(obj))
@@ -136,6 +120,21 @@
 
 SCRIPTS_API const char *Get_Translated_Preset_Name_Ini(GameObject *obj)
 {
+	if (Is_C4(obj))
+	{
+		if (Get_C4_Mode(obj) == 1)
+		{
+			return newstr("Remote C4");
+		}
+		else if (Get_C4_Mode(obj) == 3)
+		{
+			return newstr("Proximity C4");
+		}
+		else if (Get_C4_Mode(obj) == 2)
+		{
+			return newstr("Timed C4");
+		}
+	}
 	if (!Translation_Overrides.Get(Commands->Get_Preset_Name(obj),0).Is_Empty())
 	{
 		return newstr(Translation_Overrides.Get(Commands->Get_Preset_Name(obj),0).Peek_Buffer());
@@ -239,6 +238,8 @@
 	}
 	AddChatHook(ChatHook);
 	AddRadioHook(RadioHook);
+	AddStockDamageHook(StockDamageHook);
+	AddTtDamageHook(TtDamageHook);
 	ObjectCreateHookStruct *h = new ObjectCreateHookStruct;
 	h->data = 0;
 	h->hook = ObjectCreateHook;
@@ -436,6 +437,30 @@
 	}
 }
 
+bool SSGMGameManager::StockDamageHook(PhysicalGameObj* damager, PhysicalGameObj* target, float damage, uint warheadId)
+{
+	for (int i = 0;i < RegisteredEvents[EVENT_STOCK_DAMAGE_HOOK].Count();i++)
+	{
+		if (!RegisteredEvents[EVENT_STOCK_DAMAGE_HOOK][i]->OnStockDamage(damager, target, damage, warheadId))
+		{
+			return false;
+		}
+	}
+	return true;
+}
+
+bool SSGMGameManager::TtDamageHook(PhysicalGameObj* damager, PhysicalGameObj* target, const AmmoDefinitionClass* ammo, const char* bone)
+{
+	for (int i = 0;i < RegisteredEvents[EVENT_TT_DAMAGE_HOOK].Count();i++)
+	{
+		if (!RegisteredEvents[EVENT_TT_DAMAGE_HOOK][i]->OnTtDamage(damager, target, ammo, bone))
+		{
+			return false;
+		}
+	}
+	return true;
+}
+
 void SSGMGameManager::FreeMapData()
 {
 	DisablePresets.Clear();
@@ -462,7 +487,6 @@
 	VehicleWreckages.Remove_All();
 	delete[] GDISpawnChar;
 	delete[] NodSpawnChar;
-	delete[] ObjectsFilename;
 	for (int i = 0;i < RegisteredEvents[EVENT_GLOBAL_INI].Count();i++)
 	{
 		RegisteredEvents[EVENT_GLOBAL_INI][i]->OnFreeData();
@@ -488,13 +512,10 @@
 	{
 		StringClass GDISpawnCharx;
 		StringClass NodSpawnCharx;
-		StringClass ObjectsFilenamex;
 		SSGMIni->Get_String(GDISpawnCharx,"General","GDISpawnChar","CnC_GDI_MiniGunner_0");
 		SSGMIni->Get_String(NodSpawnCharx,"General","NodSpawnChar","CnC_Nod_Minigunner_0");
-		SSGMIni->Get_String(ObjectsFilenamex,"General","ObjectsFilename","Objects.ddb");
 		GDISpawnChar = newstr(GDISpawnCharx);
 		NodSpawnChar = newstr(NodSpawnCharx);
-		ObjectsFilename = newstr(ObjectsFilenamex);
 		InvincibleBuildings = SSGMIni->Get_Bool("General","InvincibleBuildings",false);
 		ForceTeam = SSGMIni->Get_Int("General","ForceTeam",-1);
 		RefillLimit = SSGMIni->Get_Int("General","RefillLimit",0);
@@ -594,9 +615,7 @@
 	{
 		GDISpawnChar = newstr("CnC_GDI_MiniGunner_0");
 		NodSpawnChar = newstr("CnC_Nod_MiniGunner_0");
-		ObjectsFilename = newstr("Objects.ddb");
 	}
-	Set_Objects_Filename(ObjectsFilename);
 	if ( freeIni )
 		Release_INI(SSGMIni);
 }
diff -uwr sourceold/scripts/gmgame.h source/scripts/gmgame.h
--- sourceold/scripts/gmgame.h	2011-10-11 21:52:45.681640600 +0800
+++ source/scripts/gmgame.h	2012-02-18 09:50:34.061523400 +0800
@@ -34,6 +34,8 @@
 	static void FreeData();
 	static void FreeMapData();
 	static void ThinkHook();
+	static bool StockDamageHook(PhysicalGameObj* damager, PhysicalGameObj* target, float damage, uint warheadId);
+	static bool TtDamageHook(PhysicalGameObj* damager, PhysicalGameObj* target, const AmmoDefinitionClass* ammo, const char* bone);
 };
 
 class SSGM_Random_Weather : public ScriptImpClass {
diff -uwr sourceold/scripts/gmplugin.h source/scripts/gmplugin.h
--- sourceold/scripts/gmplugin.h	2011-10-11 21:52:40.915039000 +0800
+++ source/scripts/gmplugin.h	2012-02-18 09:50:34.054687500 +0800
@@ -30,6 +30,8 @@
 	EVENT_CHARACTER_PURCHASE_HOOK,
 	EVENT_THINK_HOOK,
 	EVENT_RADIO_HOOK,
+	EVENT_STOCK_DAMAGE_HOOK,
+	EVENT_TT_DAMAGE_HOOK,
 	EVENT_COUNT
 };
 
@@ -53,6 +55,8 @@
 	virtual int OnCharacterPurchase(BaseControllerClass *base,GameObject *purchaser,unsigned int cost,unsigned int preset,const char *data) {return -1;}; //called on character purchase
 	virtual void OnThink() {}; //called once per frame
 	virtual bool OnRadioCommand(int PlayerType, int PlayerID, int AnnouncementID, int IconID, uint8 AnnouncementType) {return true;} //called on radio command
+	virtual bool OnStockDamage(PhysicalGameObj* damager, PhysicalGameObj* target, float damage, uint warheadId) { return true; } //called on damage from clients with version <4.0
+	virtual bool OnTtDamage(PhysicalGameObj* damager, PhysicalGameObj* target, const AmmoDefinitionClass* ammo, const char* bone) { return true; } //called on damage from clients with version >=4.0
 };
 
 typedef Plugin *(*Plugin_Init_Type) ();
diff -uwr sourceold/scripts/gmvehicle.cpp source/scripts/gmvehicle.cpp
--- sourceold/scripts/gmvehicle.cpp	2011-10-11 23:04:32.766601500 +0800
+++ source/scripts/gmvehicle.cpp	2012-02-17 17:47:52.633789000 +0800
@@ -491,6 +491,8 @@
 	Commands->Start_Timer(obj,this,WreckDestroySelfTime,1001);//destroy the wreck after timer expires
 	Set_Skin(obj,"Blamo");//needed to avoid destruction of the wreck on vehicle Killed
 	Commands->Start_Timer(obj,this,2.0f,1000);//set skin to CNCVehicleHeavy again
+	Set_Max_Health(obj,Commands->Get_Health(obj) + Commands->Get_Shield_Strength(obj));
+	Set_Max_Shield_Strength(obj,0);
 	Commands->Set_Health(obj,100);
 	Commands->Disable_Physical_Collisions(obj);
 	Commands->Set_Player_Type(obj,-2);
diff -uwr sourceold/scripts/iran_scripts.cpp source/scripts/iran_scripts.cpp
--- sourceold/scripts/iran_scripts.cpp	2011-11-22 14:49:49.201171800 +0800
+++ source/scripts/iran_scripts.cpp	2012-01-05 21:21:34.000000000 +0800
@@ -34,6 +34,7 @@
 			{
 				Commands->Select_Weapon(checkplayerobj,"");
 				Commands->Select_Weapon(checkplayerobj,"CnC_Weapon_NukeBeacon_Player");
+				
 			}
 			Commands->Start_Timer(obj,this,0.5,number);
 		}
@@ -76,7 +77,13 @@
 
 void Iran_Vehicle_All_Kill_Zone::Entered(GameObject *obj,GameObject *enter)
 {
-	if (Is_Vehicle(enter))
+
+	if (stristr(Commands->Get_Preset_Name(enter),"Destroyed"))
+	{
+		saved = Commands->Get_ID(enter);
+		Commands->Start_Timer(obj,this,2.5f,1);
+	}
+	else if (Is_Vehicle(enter))
 	{
 		int type = Commands->Get_Player_Type(enter);
 		if ( type < 0 || type > 1 )
@@ -98,14 +105,27 @@
 
 void Iran_All_Kill_Zone::Entered(GameObject *obj,GameObject *enter)
 {
+	if (stristr(Commands->Get_Preset_Name(enter),"Destroyed"))
+	{
+		saved = Commands->Get_ID(enter);
+		Commands->Start_Timer(obj,this,2.5f,1);
+	}
+
+	else if (enter)
+	{
 	int type = Commands->Get_Player_Type(enter);
 	if ( type < 0 || type > 1 )
 	{
 		return;
 	}
+		if (Get_Fly_Mode(enter))
+		{
+			return;
+		}
 	saved = Commands->Get_ID(enter);
 	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),1);
 }
+}
 
 void Iran_All_Kill_Zone::Timer_Expired(GameObject *obj,int number)
 {
@@ -122,6 +142,11 @@
 	{
 		return;
 	}
+
+	if (Get_Fly_Mode(enter))
+	{
+		return;
+	}
 	saved = Commands->Get_ID(enter);
 	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),1);
 }
@@ -136,15 +161,16 @@
 
 void Iran_Vehicle_Ground_Kill_Zone::Entered(GameObject *obj,GameObject *enter)
 {
-	if (Is_Vehicle(enter))
+	if (stristr(Commands->Get_Preset_Name(enter),"_Destroyed"))
 	{
-		if (Get_Vehicle_Mode(enter) != VEHICLE_TYPE_FLYING)
+		saved = Commands->Get_ID(enter);
+		Commands->Start_Timer(obj,this,2.5f,1);
+	}
+
+	else if (Is_Vehicle(enter))
 		{
-			int type = Commands->Get_Player_Type(enter);
-			if ( type < 0 || type > 1 )
+		if (Get_Vehicle_Mode(enter) != VEHICLE_TYPE_FLYING)
 			{
-				return;
-			}
 			saved = Commands->Get_ID(enter);
 			Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),1);
 		}
@@ -184,9 +210,48 @@
 	}
 }
 
+void Iran_Invisible_Blocker::Created(GameObject *obj)
+{
+	Vector3 Position = Commands->Get_Position(obj);
+	float Facing = Commands->Get_Facing(obj);
+
+	Commands->Destroy_Object(obj);
+
+	GameObject* Blocker = Commands->Create_Object("GDI_Ceiling_Gun_AGT", Position);
+	Commands->Set_Facing(Blocker, Facing);
+	Commands->Set_Model(Blocker,"dsp_torture_wal");
+
+	Commands->Set_Player_Type(Blocker, -2);
+
+	Commands->Set_Is_Visible(Blocker, false);
+	Commands->Set_Is_Rendered(Blocker, false);
+	Commands->Display_Health_Bar(Blocker, false);
+}
+
+void Iran_Invisible_Blocker_Visible::Created(GameObject *obj)
+{
+	Vector3 Position = Commands->Get_Position(obj);
+	float Facing = Commands->Get_Facing(obj);
+
+	Commands->Destroy_Object(obj);
+
+	GameObject* Blocker = Commands->Create_Object("GDI_Ceiling_Gun_AGT", Position);
+	Commands->Set_Facing(Blocker, Facing);
+	Commands->Set_Model(Blocker,"dsp_torture_wal");
+
+	Commands->Set_Player_Type(Blocker, -2);
+
+}
+
 ScriptRegistrant<Iran_Beaconing_Prevention_Zone> Iran_Beaconing_Prevention_Zone_Registrant("Iran_Beaconing_Prevention_Zone", "");
-ScriptRegistrant<Iran_Vehicle_All_Kill_Zone> Iran_Vehicle_All_Kill_Zone_Registrant("Iran_Vehicle_All_Kill_Zone", "Time:float");
-ScriptRegistrant<Iran_All_Kill_Zone> Iran_All_Kill_Zone_Registrant("Iran_All_Kill_Zone", "Time:float");
+
 ScriptRegistrant<Iran_Star_Kill_Zone> Iran_Star_Kill_Zone_Registrant("Iran_Star_Kill_Zone", "Time:float");
+ScriptRegistrant<Iran_All_Kill_Zone> Iran_All_Kill_Zone_Registrant("Iran_All_Kill_Zone", "Time:float");
+
+ScriptRegistrant<Iran_Vehicle_All_Kill_Zone> Iran_Vehicle_All_Kill_Zone_Registrant("Iran_Vehicle_All_Kill_Zone", "Time:float");
 ScriptRegistrant<Iran_Vehicle_Ground_Kill_Zone> Iran_Vehicle_Ground_Kill_Zone_Registrant("Iran_Vehicle_Ground_Kill_Zone", "Time:float");
 ScriptRegistrant<Iran_Vehicle_Flying_Kill_Zone> Iran_Vehicle_Flying_Kill_Zone_Registrant("Iran_Vehicle_Flying_Kill_Zone", "Time:float");
+
+ScriptRegistrant<Iran_Invisible_Blocker> Iran_Invisible_Blocker_Registrant("Iran_Invisible_Blocker", "");
+ScriptRegistrant<Iran_Invisible_Blocker_Visible> Iran_Invisible_Blocker_Visible_Registrant("Iran_Invisible_Blocker_Visible", "");
+
diff -uwr sourceold/scripts/iran_scripts.h source/scripts/iran_scripts.h
--- sourceold/scripts/iran_scripts.h	2011-11-22 14:49:49.208007800 +0800
+++ source/scripts/iran_scripts.h	2012-01-05 21:16:28.000000000 +0800
@@ -49,3 +49,14 @@
 	void Entered(GameObject *obj,GameObject *enter);
 	void Timer_Expired(GameObject *obj,int number);
 };
+
+// Destroys the object it's attached to and crates an invisible laser fence blocker
+// at the same position and facing
+class Iran_Invisible_Blocker : public ScriptImpClass {
+	void Created(GameObject *obj);
+};
+
+// Same as above but shows the laser fence, for placing purposes 
+class Iran_Invisible_Blocker_Visible : public ScriptImpClass {
+	void Created(GameObject *obj);
+};
\ No newline at end of file
diff -uwr sourceold/scripts/jfwcine.cpp source/scripts/jfwcine.cpp
--- sourceold/scripts/jfwcine.cpp	2011-10-11 23:05:22.311523400 +0800
+++ source/scripts/jfwcine.cpp	2012-02-13 19:12:33.892000000 +0800
@@ -1338,6 +1338,7 @@
 void JFW_Cinematic_Kill_Object::Created(GameObject *obj)
 {
 	Commands->Apply_Damage(obj,10000,"BlamoKiller",0);
+	Destroy_Script();
 }
 
 ScriptRegistrant<JFW_Zone_Play_Cinematic> JFW_Zone_Play_Cinematic_Registrant("JFW_Zone_Play_Cinematic","Script_Name:string,location:vector3,Player_Type:int,Facing:float");
diff -uwr sourceold/scripts/jfwcust.cpp source/scripts/jfwcust.cpp
--- sourceold/scripts/jfwcust.cpp	2011-12-01 12:26:58.960937500 +0800
+++ source/scripts/jfwcust.cpp	2012-02-13 19:32:56.754304700 +0800
@@ -72,6 +72,7 @@
 	param = Get_Int_Parameter("Param");
 	object = Commands->Find_Object(ID);
 	Commands->Send_Custom_Event(obj,object,type,param,0);
+	Destroy_Script();
 }
 
 void JFW_Custom_Destroy_Building::Custom(GameObject *obj,int type,int param,GameObject *sender)
@@ -255,6 +256,7 @@
 	int msg = Get_Int_Parameter("Message");
 	int ID = Get_Int_Parameter("ID");
 	Commands->Send_Custom_Event(obj,Commands->Find_Object(ID),msg,0,0);
+	Destroy_Script();
 }
 
 void JFW_Teleport_Custom::Custom(GameObject *obj,int type,int param,GameObject *sender)
@@ -389,6 +391,7 @@
 void JFW_Created_Send_Custom::Created(GameObject *obj)
 {
 	Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("ID")),Get_Int_Parameter("Message"),0,0);
+	Destroy_Script();
 }
 
 void JFW_Damaged_Send_Custom::Damaged(GameObject *obj,GameObject *damager,float amount)
@@ -1179,6 +1182,7 @@
 	param = Commands->Get_ID(obj);
 	object = Commands->Find_Object(ID);
 	Commands->Send_Custom_Event(obj,object,type,param,0);
+	Destroy_Script();
 }
 
 void JFW_Death_Send_Custom_Driver_ID::Killed(GameObject *obj,GameObject *killer)
@@ -1192,6 +1196,7 @@
 	param = DriverID;
 	object = Commands->Find_Object(ID);
 	Commands->Send_Custom_Event(obj,object,type,param,0);
+	Destroy_Script();
 }
 
 void JFW_Death_Send_Custom_Driver_ID::Created(GameObject *obj)
@@ -1592,6 +1597,7 @@
 {
 	int msg = Get_Int_Parameter("Message");
 	Commands->Send_Custom_Event(obj,obj,msg,0,0);
+	Destroy_Script();
 }
 
 ScriptRegistrant<JFW_Send_Custom_Distance_Objects_Timer> JFW_Send_Custom_Distance_Objects_Timer_Registrant("JFW_Send_Custom_Distance_Objects_Timer","Distance:float,Message:int,Time:float,TimerNum:int,Player_Type:int");
diff -uwr sourceold/scripts/jfwdmg.cpp source/scripts/jfwdmg.cpp
--- sourceold/scripts/jfwdmg.cpp	2011-10-11 23:05:17.557617100 +0800
+++ source/scripts/jfwdmg.cpp	2012-02-13 19:32:56.397859400 +0800
@@ -30,6 +30,7 @@
 	spawn_location.Z = spawn_location.Z + f;
 	object = Commands->Create_Object (c,spawn_location);
 	Commands->Set_Facing(object,facing);
+	Destroy_Script();
 }
 
 void JFW_Timer_Destroy_Building::Created(GameObject *obj)
@@ -77,6 +78,7 @@
 	c = Get_Parameter("Explosion");
 	v = Commands->Get_Position(obj);
 	Commands->Create_Explosion (c,v,0);
+	Destroy_Script();
 }
 
 void JFW_Give_Points_On_Death::Killed(GameObject *obj,GameObject *killer)
@@ -88,6 +90,7 @@
 		return;
 	}
 	Commands->Give_Points(killer,Get_Float_Parameter("Points"),Get_Int_Parameter("Whole_Team"));
+	Destroy_Script();
 }
 
 void JFW_Armour_Regen::Created(GameObject *obj)
@@ -157,6 +160,7 @@
 void JFW_Death_Destroy_Object::Killed(GameObject *obj,GameObject *killer)
 {
 	Commands->Destroy_Object(Commands->Find_Object(Get_Int_Parameter("ID")));
+	Destroy_Script();
 }
 
 void JFW_Invulnerability_Timer::Created(GameObject *obj)
@@ -227,6 +231,7 @@
 		object = Commands->Create_Object (c,spawn_location);
 		Commands->Set_Facing(object,facing);
 	}
+	Destroy_Script();
 }
 
 void JFW_Spawn_Object_Death_Enable::Register_Auto_Save_Variables()
@@ -252,6 +257,7 @@
 		object = Commands->Create_Object (c,spawn_location);
 		Commands->Set_Facing(object,facing);
 	}
+	Destroy_Script();
 }
 
 void JFW_Spawn_Object_Death_Enable_Random::Created(GameObject *obj)
@@ -292,6 +298,7 @@
 			Commands->Set_Facing(object,facing);
 		}
 	}
+	Destroy_Script();
 }
 
 void JFW_Spawn_Object_Death_Enable_Random::Register_Auto_Save_Variables()
@@ -629,6 +636,7 @@
 	c = Get_Parameter("Explosion");
 	v = Commands->Get_Position(obj);
 	Commands->Create_Explosion (c,v,Commands->Find_Object(DriverID));
+	Destroy_Script();
 }
 
 void JFW_Random_DriverDeath::Created(GameObject *obj)
@@ -849,6 +857,7 @@
 		object = Commands->Create_Object (c,spawn_location);
 		Commands->Set_Facing(object,facing);
 	}
+	Destroy_Script();
 }
 
 void JFW_Spawn_Object_Death_Team::Killed(GameObject *obj,GameObject *killer)
@@ -872,6 +881,7 @@
 	spawn_location.Z = spawn_location.Z + f;
 	object = Commands->Create_Object (c,spawn_location);
 	Commands->Set_Facing(object,facing);
+	Destroy_Script();
 }
 
 void JFW_Pilot_Repair::Created(GameObject *obj)
@@ -906,6 +916,7 @@
 void JFW_Damage_Occupants_Death::Killed(GameObject *obj,GameObject *killer)
 {
 	Damage_Occupants(obj,Get_Float_Parameter("Damage"),Get_Parameter("Warhead"));
+	Destroy_Script();
 }
 
 void JFW_Engineer_Target_2::Register_Auto_Save_Variables()
@@ -1212,6 +1223,7 @@
 	{
 		Commands->Send_Custom_Event(obj,Find_Object_With_Script("JFW_Kill_Message_Display"),Get_Int_Parameter("Message"),0,0);
 	}
+	Destroy_Script();
 }
 
 void JFW_C4_Explode::Created(GameObject *obj)
@@ -1221,6 +1233,7 @@
 	{
 		Commands->Create_Explosion(Get_Parameter("Explosion"),Commands->Get_Position(obj),0);
 	}
+	Destroy_Script();
 }
 
 void JFW_Beacon_Building::Created(GameObject *obj)
